<template>
  <div>
    <div
      v-if="!isNew"
      class="row"
    >
      <div class="col-xs-6">
        <ObDatePickerConstructor
          :value="dataSource.eventData && dataSource.eventData.occurredAt"
          label="Дата и время создания"
          :is-time="true"
          :readonly="true"
        />
      </div>
      <div class="col-xs-6">
        <ObInput
          label="Инициатор события"
          :value="dataSource.eventData && dataSource.eventData.authorTitle"
          :readonly="true"
        />
      </div>
    </div>
    <ObInput
      label="Адрес точки"
      :value="dataSource.point && dataSource.point.addressTitle"
      pre-icon="pin"
      :readonly="true"
    />
    <div class="title">Старый г{{ contractorTypeWordRoot }}ь</div>
    <ObInput
      :label="`Г${contractorTypeWordRoot }ь`"
      :value="dataSource.point && dataSource.point.title"
      :readonly="true"
    />
    <div
      v-if="dataSource.inn"
      class="block-inn"
    >
      <span>ИНН</span>
      <span>{{ dataSource.inn }}</span>
    </div>
    <div class="title">Выберите нового г{{ contractorTypeWordRoot }}я</div>
    <div class="row">
      <div class="col-xs-12">
        <ConsignorOrConsigneeSelect
          :value="formData.consigneeOrConsignorUuidNew"
          :ownerUuid="order.cargoOwnerUuid"
          :address-title="dataSource.addressTitle"
          :address="dataSource.point"
          :point-type="formData.consigneeOrConsignor"
          @on-select-contractor="onSelectContractor"
        />
      </div>
    </div>
    <div class="row">
      <div class="col-xs-12">
        <ObInput
          :value="formData.tsdAddress"
          label="Адрес для документации (ТСД)"
          placeholder="Укажите адрес"
          :readonly="!isNew"
          @input="onChangeField('tsdAddress', $event)"
        />
      </div>
    </div>
    <div class="row">
      <div class="col-xs-12">
        <ObTextarea
          :value="formData.comment"
          label="Комментарий"
          placeholder="Добавьте комментарий"
          :readonly="!isNew && !isNewForm"
          @input="onChangeField('comment', $event)"
        />
      </div>
    </div>
    <template v-if="formData.eventData && (!formData.eventData.fileUuids || !formData.eventData.fileUuids.length) && isEditMode && !isNewForm">
      <div class="title">Нет прикрепленных файлов</div>
    </template>
    <template v-if="(formData.eventData && formData.eventData.fileUuids && formData.eventData.fileUuids.length) || isNew || isNewForm">
      <div class="title">Прикрепленные файлы</div>
      <ObUploader
        ref="uploader"
        multiple
        :value="currentFiles"
        data-qa="uploader"
        :is-read-only="!isNew && !isNewForm"
        :upload-method="uploadMethod"
        @process-start="startUploadFiles"
        @change="onUploadHandler"
      />
    </template>
  </div>
</template>

<script>
import api from "@/api"
import ObInput from 'common-components/src/obComponents/obInput'
import ObTextarea from 'common-components/src/obComponents/obTextarea'
import ObDatePickerConstructor from 'common-components/src/obComponents/obDatePickerConstructor'
import ObUploader from 'common-components/src/obComponents/obUploader'
import ConsignorOrConsigneeSelect from '@/components/Order/orderItem/ConsignorOrConsigneeSelect'

export default {
  name: 'consigneeOrConsignorEventForm',
  components: {
    ObInput,
    ConsignorOrConsigneeSelect,
    ObTextarea,
    ObUploader,
    ObDatePickerConstructor,
  },
  props: {
    formData: {
      type: Object,
      default: () => {}
    },
    isEditMode: {
      type: Boolean,
      default: false
    },
    isNew: {
      type: Boolean,
      default: false
    },
    isNewForm: {
      type: Boolean,
      default: false
    },
    dataSource: {
      type: Object,
      default: () => {}
    },
    order: {
      type: Object,
      default: () => {}
    },
  },
  watch: {
    'formData.fileUuids'(value) {
      if (!value) {
        this.$refs.uploader && this.$refs.uploader.clearFiles()
      }
    }
  },
  computed: {
    uploadMethod () {
      return api.files.postFile
    },
    currentFiles () {
      return this.dataSource.filesData
    },
    isConsignor () {
      return this.formData.consigneeOrConsignor === 'CONSIGNOR'
    },
    contractorTypeWordRoot () {
      return this.isConsignor
        ? 'рузоотправител'
        : 'рузополучател'
    }
  },
  methods: {
    startUploadFiles () {
      this.formData.fileUuids = 'loading'
    },
    async onUploadHandler (data) {
      data = data.map(file => file.uuid)

      if (!data || !data.length) {
        this.onChangeField('fileUuids', null)
        return
      }

      this.onChangeField('fileUuids', data)
    },
    onChangeField (path, value) {
      this.$emit('change-field', { path, value })
    },
    onSelectContractor (item) {
      this.onChangeField('consigneeOrConsignorUuidNew', item.uuid)
    }
  }
}
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/mixins";

.row-input {
  margin-right: 0;
  margin-left: 0;
  flex-wrap: nowrap;
  &__item {
    width: 212px;
    flex-grow: 2;
    &:not(:last-child) {
      margin-right: 10px;
    }
  }
  &__counter {
    width: 135px;
  }
}

.block-inn {
  margin-bottom: 10px;
  margin-top: 10px;
  span {
    @include font-mixin(14px, 18px, 400, $color-text-base);
    &:first-child {
      margin-right: 7px;
      color: $color-grey-label;
    }
  }
}
</style>